###############################################################################
# Draft_Post.pm                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.11                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2015 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
# Written by Dandello (D.A.Rorabaugh)                                         #
###############################################################################

$draft_postpmver = 'YaBB 2.6.11 $Revision: 0.1 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage('Post');
LoadLanguage('LivePreview');
LoadLanguage('Mods/Draft_Post');

require Sources::SpamCheck;
require Sources::PostBox;
get_micon();
get_template('Post');

sub save_post_draft {
    if ( $FORM{'post'} ) {
        require Sources::Post;
        Post2();
    return;
    }
    else {
    if ( $iamguest ) {
        fatal_error('not_logged_in');
    }
    my (
        $email,     $ns,    $notify, $hasnotify, $i,
        $mnum,      $msub,  $mname,  $memail,    $mdate,
        $musername, $micon, $mstate, $pageindex, $tempname
    );

    # Get the form values
    $name     = $FORM{'name'};
    $email    = $FORM{'email'};
    $subject  = $FORM{'subject'};
    $message  = $FORM{'message'};
    $icon     = $FORM{'icon'};
    $ns       = $FORM{'ns'};
    $ann      = $FORM{'ann'};
    $threadid = $FORM{'threadid'};
    $posttime   = $FORM{'post_entry_time'};

    # Check if poster isn't using a distilled email domain
    email_domain_check($email);
    my $spamdetected = spamcheck("$name $subject $message");
    if ( !${ $uid . $FORM{$username} }{'spamcount'} ) {
        ${ $uid . $FORM{$username} }{'spamcount'} = 0;
    }

    $allowattach = 0;
    # End Permission Checks

    ## clean name and email - remove | from name and turn any _ to spaces for mail
    if ( $name && $email ) {
        ToHTML($name);
        $email =~ s/\|//gxsm;
        ToHTML($email);
        $tempname = $name;
        $name =~ s/\_/ /gsm;
    }

    # Fixes a bug with posting hexed characters.
    $name =~ s/amp;//gxsm;

    spam_protection();

    $subject =~ s/[\r\n]//gxsm;
    my $testsub = $subject;
    $testsub =~ s/ |\&nbsp;//gsm;
    if ( $testsub eq q{} ) {
        fatal_error( 'useless_post', "$testsub" );
    }

    my $testmessage = regex_1($message);
    if ( $testmessage eq q{} && $message ne q{} ) {
        fatal_error( 'useless_post', "$testmessage" );
    }

    if ( !$minlinkpost ) { $minlinkpost = 0; }
    if ( ${ $uid . $username }{'postcount'} < $minlinkpost
        && !$staff )
    {
        if (   $message =~ m{http:\/\/}xsm
            || $message =~ m{https:\/\/}xsm
            || $message =~ m{ftp:\/\/}xsm
            || $message =~ m{www.}xsm
            || $message =~ m{ftp.}xsm =~ m{\[url}xsm
            || $message =~ m{\[link}xsm
            || $message =~ m{\[img}xsm
            || $message =~ m{\[ftp}xsm )
        {
            fatal_error('no_links_allowed');
        }
    }

    FromChars($subject);
    $convertstr = $subject;
    $convertcut = $set_subjectMaxLength + ( $subject =~ /^Re: /sm ? 4 : 0 );
    CountChars();
    $subject = $convertstr;
    ToHTML($subject);
    $doadsubject = $subject;

    $message = regex_2($message);

    FromChars($message);
    ToHTML($message);
    $message = regex_3($message);
    CheckIcon();

    $messageid = getnewid();
    @draftmessages = ();
    fopen( DRAFT, "<$memberdir/$username.pdraft" );
    @draftmessages = <DRAFT>;
    fclose(DRAFT);
    $draftLim = $#draftmessages + 1;
    if ( $enable_draft_lim != 0 && $draftLim >= $enable_draft_lim ) {
        fatal_error('dp_overlimit');
    }
    else {
    fopen( DRAFT, ">$memberdir/$username.pdraft" ) or fatal_error( 'cannot_open', "$memberdir/$username.pdraft", 1 );
    if ( !$FORM{'save_post_draft'} || ( $FORM{'save_post_draft'} && !$FORM{'draftid'} ) ) {
        print {DRAFT}
qq~$messageid|$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||\n~
              or croak "$croak{'print'} DRAFT";
        print {DRAFT} @draftmessages or croak "$croak{'print'} DRAFT";
    }
    elsif ( $FORM{'save_post_draft'} && $FORM{'draftid'} ) {
        ## resaving draft - find draft message id and amend the entry
        for my $outmessage (@draftmessages) {
            chomp $outmessage;
            @outmessage = split /\|/xsm, $outmessage;
            if ( $outmessage[0] != $FORM{'draftid'} ) {
                print {DRAFT} "$outmessage\n"
                  or croak "$croak{'print'} OUTBOX";
            }
            else {
                print {DRAFT}
qq~$FORM{'draftid'}|$subject|$name|$email|$outmessage[4]|$username|$icon|0|$user_ip|$message|$ns|$date||\n~
          or croak "$croak{'print'} DRAFT";
            }
        }
    }
    fclose(DRAFT);
    $yySetLocation = qq~$scripturl?action=pdraft~;
    redirectexit();
    }
    return;
}

sub show_post_draft {
    get_template('Mods/Draft_Post');
    fopen( USRFILE, "<$memberdir/$username.pdraft" );
    my @messages = <USRFILE>;
    fclose( USRFILE );
    $show_post_draft = $myshow_post_draft;
    $nopsave = q{};
    $show1 = q{};
    $dpintext = q{};
    $my_dpintext = q{};

    if ( !@messages ) {
        $show_post_draft = $my_pnomesssages;
        $post_dima .= q{};
    }
    else { $show1 = qq~<tr>
                <td class="titlebg">$inmes_txt{'70'}</td>
                <td class="titlebg">$inmes_txt{'datesave'}</td>
                <td class="titlebg"></td>
            </tr>~;
#qq~$messageid|$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||\n~
        for (@messages) {
            @mydrafts = split /[|]/xsm, $_;
            $date_save = timeformat( $mydrafts[0] );
            my $date_mod = q{};
            if ( $mydrafts[11] ) {
                $date_mod .= qq~ ($inmes_txt{'edit'} ~ . timeformat( $mydrafts[11], 1 ) . q~)~;
            }
            if ( $INFO{'num'} ) {
                $draft_thrd = qq~;num=$INFO{'num'}~;
            }
            if ( $INFO{'board'} ) {
                $draft_brd = qq~;board=$INFO{'board'}~;
            }
            $show1 .= qq~<tr class="windowbg2">
                <td><img src="$micon_bg{'xx'}" alt="" /> <a href="$scripturl?action=pdrecall;id=$mydrafts[0]$draft_thrd$draft_brd">$mydrafts[1]</a></td>
                <td>$date_save$date_mod</td>
                <td><input type="checkbox" name="message$mydrafts[0]" id="message$mydrafts[0]" class="cursor" value="1" /> <label for="message$mydrafts[0]">$inmes_txt{'delete'}</label></td>
            </tr>~;
        }
        $dpmessageCounter = @messages;
        if ( $dpmessageCounter != 0 && $enable_draft_lim != 0 ) {
            $dpimpercent = int( 100 / $enable_draft_lim * $dpmessageCounter );
            $dpimbar     = int( 200 / $enable_draft_lim * $dpmessageCounter );
            $dpimrest = 200 - $dpimbar;
            if ( $dpimbar > 200 ) { $dpimbar  = 200; }
            if ( $dpimrest <= 0 ) { $dorest = q{}; }
            else {
                $dorest =
qq~<img src="$imagesdir/$IM_usageempty" height="8" width="$dpimrest" alt="" />~;
            }
            $imbargfx =
qq~$inmes_imtxt{'67'}:&nbsp;<img src="$imagesdir/$IM_usage" alt="" /><img src="$imagesdir/$IM_usagebar" height="8" width="$dpimbar" alt="" />$dorest<img src="$imagesdir/$IM_usage" alt="" />&nbsp;$dpimpercent&nbsp;%&nbsp;<br />~;
        $my_dpintext .= $myshow_dp_usage;
        $dpintext .=
qq~$imbargfx($inmes_imtxt{'13'} $dpmessageCounter $inmes_imtxt{'01'} $enable_draft_lim $inmes_imtxt{'19'} $inmes_txt{'pdraft'})~;
        }
        else {
            $dpintext   = q~&nbsp;~;
            $imbargfx = q~&nbsp;~;
        }

        $show1 .= $my_delstore;
    $removeButton =
qq~<input type="submit" name="daction" value="$inmes_txt{'remove'}" class="button" onclick="return confirm('$inmes_txt{'delmultipd'}');" />~;
    $inmes_txt{'777b'} =~ s/REMOVE/$removeButton/sm;
    $removeButton = $inmes_txt{'777b'};
    $post_dima .= qq~ $removeButton<br />~;
    }
    $show_post_draft =~ s/{yabb show1}/$show1/gsm;
    $show_post_draft =~ s/{yabb post_dima}/$post_dima/gsm;
    $show_post_draft =~ s/{yabb my_dpintext}/$my_dpintext/gsm;
    $show_post_draft =~ s/{yabb dpintext}/$dpintext/gsm;

    return $show_post_draft;
}

sub Del_Some_PD {
    LoadLanguage('InstantMessage');
    if ($iamguest) { fatal_error('dp_members_only'); }

    fopen( USRFILE, "<$memberdir/$username.pdraft" );
    my @messages = <USRFILE>;
    fclose( USRFILE );
    my @delpost = ();
    # deleting
    if ( $INFO{'deleteid'} ) {
        $FORM{ 'message' . $INFO{'deleteid'} } = 1;
    }    # single delete
    @delpost = ();
        for (@messages) {
            my @m = split /[|]/xsm, $_;
            chomp @m;
            if ( !exists $FORM{ 'message' . $m[0] } ) {
                push @delpost, $_;
            }
        }
    fopen( USRFILE, ">$memberdir/$username.pdraft" );
    print {USRFILE} @delpost or croak "$croak{'print'} USRFILE";
    fclose(USRFILE);

    $yySetLocation = qq~$scripturl?action=pdraft~;
    redirectexit();
    return;
}

sub ModifyDraft {
    if ($iamguest) { fatal_error('members_only'); }

    $postid   = $INFO{'id'};
    $threadid =  $INFO{'num'};
    fopen( USRFILE, "<$memberdir/$username.pdraft" );
    my @messages = <USRFILE>;
    fclose( USRFILE );
#qq~$messageid|$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||\n~
    for (@messages) {
            @mydrafts = split /[|]/xsm, $_;
#            $sub,   $mname,   $memail, $mdate,   $musername,
#            $micon, $mattach, $mip,    $message, $mns,
#            $mlm,   $mlmb,    $mfn
        if ( $mydrafts[0] == $postid ) {
            $lastmod_a = $mydrafts[11] ? timeformat($mydrafts[11]) : q{-};
            $nscheck   = $mydrafts[10] ? ' checked'       : q{};

            $lastmod = $mypost_lastmod;
            $lastmod =~ s/{yabb lastmod_a}/$lastmod_a/sm;

            $icon = $mydrafts[6];
            $message = $mydrafts[9];
            $message =~ s/<br \/>/\n/igsm;
            $message =~ s/<br>/\n/igxsm;
            $message =~ s/ \&nbsp; \&nbsp; \&nbsp;/\t/igsm;
            $settofield = 'message';
            if ( $threadid ) {
                fopen( FILE, "$datadir/$threadid.txt" ) or fatal_error( 'cannot_open', "$datadir/$threadid.txt", 1 );
                @{ $thread_arrayref{$threadid} } = <FILE>;
                fclose(FILE);
                ( @mythrd ) = split /[|]/xsm, ${ $thread_arrayref{$threadid} }[0];
                $msubject =~ s/\bre:\s+//igxsm;
                $sub        = "Re: $mythrd[0]";
            }
            else {
                $sub = $mydrafts[1];
            }

        }
    }
    $submittxt   = $post_txt{'105'};
    $destination = 'save_post_draft';
    $post        = 'postmodify';
    require Sources::Post;
    $yytitle       = $post_txt{'66a'};
    if ( $INFO{'board'} || $INFO{'num'} ) {
        $yytitle       = $post_txt{'66b'};
        $post = 'post';
    }

    $mename        = $mydrafts[2];
    $thismusername = $mydrafts[5];
    $tmpmdate      = $mydrafts[4];

    Postpage();
    template();
    return;
    }
}

1;