<id>
Draft Posts for YaBB 2.6.11
</id>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<version>
0.1
</version>

<mod info>
This mod lets users save Draft Posts in a manner similar to saving drafts of personal messages. It also allows the admin to set limits on how many drafts can be stored.

First release on Feb 6, 2015

Installation:
Use BoardMod or manually edit files.

Instructions:
Upload in ASCII:
cgi-bin/yabb2/Admin/ModList.pm
cgi-bin/yabb2/Admin/Admin.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Main.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/MyCenter.pm
cgi-bin/yabb2/Sources/Post.pm
cgi-bin/yabb2/Sources/Profile.pm
cgi-bin/yabb2/Sources/SubList.pm
Templates/default/MyCenter.template
Templates/default/Post.template

Upload Draft_Post.pm to Sources/Mods
Upload Draft_Post.template to Templates/default/Mods
Upload Draft_Post.lng to Languages/English/Mods
</mod info>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $draftposts = q~Draft Posts|Dandello|Allows members to save drafts of topic posts.|0.1|02/04/2015~;
    push @installed_mods, $draftposts;
</add before>

<edit file>
Admin/Admin.pm
</edit file>

<search for>
                unlink "$memberdir/$currentmem.imdraft";
</search for>

<add after>
                unlink "$memberdir/$currentmem.pmdraft";
</add after>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
1;
</search for>

<add before>
\$enable_draft = $enable_draft;  #enable users to save draft topic posts
\$enable_draft_lim = $enable_draft_lim;  #limit the number of saved post drafts

</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
            name => 'enable_spell_check',
            validate => 'boolean',
        },
</search for>

<add after>
        {
            description => qq~<label for="enable_draft">$admin_txt{'draftp'}</label>~,
            input_html => qq~<input type="checkbox" name="enable_draft" id="enable_draft" value="1"${ischecked($enable_draft)} />~,
            name => 'enable_draft',
            validate => 'boolean',
        },
        {
            description => qq~<label for="enable_draft_lim">$admin_txt{'draftpl'}</label>~,
            input_html => qq~<input type="text" size="5" name="enable_draft_lim" id="enable_draft_lim" value="$enable_draft_lim" />~,
            name => 'enable_draft_lim',
            depends_on => ['enable_draft'],
            validate => 'number',
        },
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'draftp'} = 'Enable users to save draft topic posts?';
$admin_txt{'draftpl'} = '&nbsp;&nbsp;&nbsp; - Maximum saved drafts in Draft Posts<br />&nbsp;&nbsp;&nbsp;<span class="small">Set to 0 to disable (not recommended)</span>';

</add before>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
$mycenter_txt{'welcometxt'} =~ s/USERLABEL/${$uid.$username}{'realname'}/gxsm;
</search for>

<add before>
if ( $enable_draft ) {
    LoadLanguage('Mods/Draft_Post');
    require Sources::Mods::Draft_Post;
}

</add before>

<search for>
    elsif ( $action eq 'myusersrecentposts' ) { $view = 'recentposts'; }
</search for>

<add after>
    elsif ( $action eq 'pdraft' ) { $view = 'pdraft'; }
</add after>

<search for>
    elsif ( $view eq 'recentposts' ) {
        $mctitle =
          "$inmes_txt{'viewrecentposts'} $inmes_txt{'viewrecentposts2'}";
    }
</search for>

<add after>
    elsif ( $view eq 'pdraft' ) {
        $mctitle = "$inmes_txt{'pdraft'}";
    }
</add after>

<search for>
    if ( $view eq 'notify' || $view eq 'favorites' || $view eq 'recentposts' ) {
</search for>

<replace>
    if ( $view eq 'notify' || $view eq 'favorites' || $view eq 'recentposts' || $view eq 'pdraft' ) {
</replace>

<search for>
    $MCPostsMenu = $my_MCPostsMenu;
</search for>

<add before>
    my $my_draft = q{};
    if ( $enable_draft ) {
        $mydrafts = qq~                <br />
                <span class="nav bold"><a href="$scripturl?action=pdraft">$inmes_txt{'viewdraft'}</a></span>~;
    }
</add before>

<search for>
## end Posts div
</search for>

<add before>
    $MCPostsMenu =~ s/{yabb  MCPost_drafts}/$mydrafts/sm;
</add before>

<search for>

    ## start PM div
</search for>

<add before>
    elsif ( $view eq 'pdraft' ) {
        require Sources::Mods::Draft_Post;
        show_post_draft();
        $MCContent .= $show_post_draft;
    }
</add before>

<edit file>
Sources/Post.pm
</edit file>

<search for>
LoadLanguage('LivePreview');
</search for>

<add after>
if ( $enable_draft ) {
    LoadLanguage('Mods/Draft_Post');
}
</add after>

<search for>
    if ( !$Quick_Post ) { $yytitle = "$t_title"; }
</search for>

<add before>
    $submittxt2  = q{};
    if ( $enable_draft && !$iamguest ) {
        $submittxt2 =
qq~ <input type="submit" name="save_post_draft" id="save_post_draft" value="$post_txt{'draft'}" accesskey="d" tabindex="7" class="button" />~;
    }
</add before>

<search for>
        && $destination ne 'guestpm2' )
</search for>

<replace>
        && $destination ne 'guestpm2'
        && $destination ne 'save_post_draft' )
</replace>

<search for>
        || $destination eq 'guestpm2' )
</search for>

<replace>
        || $destination eq 'guestpm2'
        || ( $destination eq 'save_post_draft' && !$INFO{'num'} && !$INFO{'board'} ) )
</replace>

<search for>
    if (  !$iamguest
        && $currentboard ne $annboard
        && $destination  ne 'modalert2' )
</search for>

<replace>
    if (  (!$iamguest
        && $currentboard ne $annboard
        && $destination ne 'modalert2')
        &&  ( $destination ne 'save_post_draft' || ( $destination eq 'save_post_draft' && ( $INFO{'board'} || $INFO{'num'} ) ) )
        )
</replace>

<search for>
        && !$Quick_Post )
</search for>

<add before>
        && ( $destination ne 'save_post_draft' || ( $destination eq 'save_post_draft' && ( $INFO{'num'} || $INFO{'board'} ) ) )
</add before>

<search for>
        elsif ( $destination eq 'guestpm2' ) {
</search for>

<replace>
        elsif ( $destination eq 'guestpm2' || ( $destination eq 'save_post_draft' && !$INFO{'board'} ) ) {
</replace>

<search for>
    if ( $destination ne 'modalert2' && $destination ne 'guestpm2' ) {
</search for>

<replace>
    if (   $destination ne 'modalert2'
        && $destination ne 'guestpm2'
        && $destination ne 'save_post_draft' )
    {
</replace>

<search for>
        && $username ne 'Guest' )
</search for>

<replace>
        && $username ne 'Guest'
        || ( $destination eq 'save_post_draft' && ( $INFO{'num'} || $INFO{'board'} ) ) )
</replace>

<search for>
                || $action eq 'modify2' )
</search for>

<replace>
                || $action eq 'modify2'
                || ( $action eq 'pdrecall' && ( $INFO{'board'} || $INFO{'num'} ) ) )
</replace>

<search for>
        if ( $destination ne 'modalert2' && $destination ne 'guestpm2' ) {
</search for>

<replace>
        if (   $destination ne 'modalert2'
            && $destination ne 'guestpm2'
            && ( $destination ne 'save_post_draft' || ( $destination eq 'save_post_draft' && ( $INFO{'board'} || $INFO{'num'} ) ) ) )
        {
</replace>

<search for>
        if (   $post ne 'imsend'
            && $postid ne 'Poll'
            && ( $action eq 'modify' || $action eq 'modify2' )
            && ( ( $staff && $staff_reason ) || $user_reason ) )
</search for>

<replace>
        if (
               $post ne 'imsend'
            && $postid ne 'Poll'
            && (   $action eq 'modify'
                || $action eq 'modify2'
                || $action eq 'pdrecall' )
            && ( ( $staff && $staff_reason ) || $user_reason )
          )
</replace>

<search for>
    #    these are the buttons to submit
</search for>

<add after>
    if ( $destination eq 'save_post_draft' ) {
        if ( $INFO{'num'} || $INFO{'board'} ) {
            $toboard = q~<input type="hidden" name="toboard" value="1" />~;
            $mysubmittxt =
qq~<input type="submit" name="$post" id="$post" value="$submittxt" accesskey="s" tabindex="5" class="button" /> <input type="hidden" name="draftid" id="draftid" value="$INFO{'id'}" /> <input type="submit" name="save_post_draft" id="save_post_draft" value="$post_txt{'draft'}" accesskey="d" tabindex="7" class="button" />~;
        }
        else {
            $mysubmittxt =
qq~<input type="hidden" name="draftid" id="draftid" value="$INFO{'id'}" /> <input type="submit" name="save_post_draft" id="save_post_draft" value="$post_txt{'draft'}" accesskey="d" tabindex="7" class="button" />~;
        }
    }
    else {
        $mysubmittxt =
qq~<input type="submit" name="$post" id="$post" value="$submittxt" accesskey="s" tabindex="5" class="button" />$submittxt2~;
    }
</add after>

<search for>
            <input type="submit" name="$post" id="$post" value="$submittxt" accesskey="s" tabindex="5" class="button" />
</search for>

<replace>
            $mysubmittxt
</replace>

<search for>
    $yymain .= $my_post_submit;
</search for>

<add before>
    $draft_note = q{};
    $draft_thrd = q{};
    $draft_brd  = q{};
    if ( $enable_draft && $action eq 'post' ) {
        if ( -e "$memberdir/$username.pdraft" ) {
            fopen( DRAFT, "<$memberdir/$username.pdraft" );
            @draftmessages = <DRAFT>;
            fclose(DRAFT);
            if ( @draftmessages > 0 ) {
                if ($threadid) {
                    $draft_thrd = qq~num=$threadid~;
                }
                else {
                    $draft_brd = qq~board=$currentboard~;
                }
                $drftmess = $#draftmessages + 1;
                $shdp_lim = q{};
                if ( $enable_draft_lim != 0 ) {
                    $shdp_lim = $post_txt{'of'};
                }
                $draft_note = $post_txt{'dposts_saved'};
                $draft_note =~ s/{yabb drftmess}/$drftmess/gsm;
                $draft_note =~ s/{yabb draft_brd}/$draft_brd/gsm;
                $draft_note =~ s/{yabb draft_thrd}/$draft_thrd/gsm;
                $draft_note =~ s/{yabb shdp_lim}/$shdp_lim/gsm;
            }
        }
    }
</add before>

<search for>
    $yymain =~ s/{yabb my_topview}/$my_tview/sm;
</search for>

<add after>
    $yymain =~ s/{yabb draft_note}/$draft_note/sm;
</add after>

<search for>
    $extensions = join q{ }, @ext;
</search for>

<add after>
    my $fadraft = q{};
    if ( $enable_draft ) {
        $fadraft = $post_txt{'pdraft'};
    }
</add after>

<search for>
      $limit != 0 ? qq~$fatxt{'3'} $limit KB~ : qq~$fatxt{'3'} $fatxt{'5'}~;
</search for>

<replace>
      $limit != 0 ? qq~$fatxt{'3'} $limit KB$fadraft~ : qq~$fatxt{'3'} $fatxt{'5'}$fadraft~;
</replace>

<search for>
sub Post2 {
    if ( $iamguest && $enable_guestposting == 0 ) {
        fatal_error('not_logged_in');
    }
</search for>

<add after>
    if ( $FORM{'save_post_draft'} ) {
        require Sources::Mods::Draft_Post;
        save_post_draft();
    return;
    }
    else {
</add after>

<search for>
    redirectexit();
    return;
}

# We load all the notification strings from a given language and store them in memory
</search for>

<replace>
    redirectexit();
    return;
    }
}

# We load all the notification strings from a given language and store them in memory
</replace>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
        unlink "$memberdir/$noteuser.imdraft";
</search for>

<add after>
        unlink "$memberdir/$noteuser.pmdraft";
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
$director{'save_post_draft'} = 'Mods/Draft_Post.pm&save_post_draft';
$director{'pdraft'} = 'MyCenter.pm&mycenter';
$director{'pdrecall'} = 'Mods/Draft_Post.pm&ModifyDraft';
$director{'deletemultiposts'} = 'Mods/Draft_Post.pm&Del_Some_PD';
$director{'getpdrafts'} = 'Mods/Draft_Post.pm&Get_Drafts';

</add before>

<edit file>
Templates/default/MyCenter.template
</edit file>

<search for>
                <span class="nav bold"><a href="$scripturl?action=favorites">$inmes_txt{'viewfavs'}</a></span>
</search for>

<add after>
                {yabb  MCPost_drafts}
</add after>

<edit file>
Templates/default/Post.template
</edit file>

<search for>
            <img src="{yabb icon_img}" alt="" /> {yabb yytitle}
</search for>

<replace>
            <img src="{yabb icon_img}" alt="" /> {yabb yytitle}{yabb draft_note}
</replace>

<search for>
            $display_txt{'646'} ({yabb topviewers}): {yabb template_viewers}
</search for>

<replace>
            $post_txt{'646'} ({yabb topviewers}): {yabb template_viewers}
</replace>